import sys, codecs, TECManager, Enumerators, types, MacOS

def createModule(name, textEncoding):
    fakeModule = types.ModuleType(name)
    fakeModule.__module__ = name
    gDecoder, gEncoder = TECManager.StatefulDecoder(textEncoding, name, 'strict'), TECManager.StatefulEncoder(textEncoding, name, 'strict')
    fakeModule.Codec = type('Codec', (object,codecs.Codec,), {'encode': gEncoder.stateless_encode, 'decode': gDecoder.stateless_decode, '_textEncoding':textEncoding})
    class StreamWriter(fakeModule.Codec, codecs.StreamWriter):
        def __init__(self, stream, errors='strict'):
            self._encoder = TECManager.StatefulEncoder(self._textEncoding, self._name, errors)
            self.encode = self._encoder.encode
            codecs.StreamWriter.__init__(self, stream, errors)
    fakeModule.StreamWriter = StreamWriter
    StreamWriter._name = name

    class StreamReader(fakeModule.Codec, codecs.StreamReader):
        def __init__(self, stream, errors='strict'):
            self._decoder = TECManager.StatefulDecoder(self._textEncoding, self._name, errors)
            self.decode = self._decoder.decode
            codecs.Streamreader.__init__(self, stream, errors)
    fakeModule.StreamReader = StreamReader
    StreamReader._name = name

    def getregentry(Codec=fakeModule.Codec, StreamReader=fakeModule.StreamReader, StreamWriter=fakeModule.StreamWriter):
        return (Codec().encode, Codec().decode, StreamReader, StreamWriter)
    fakeModule.getregentry = getregentry
    sys.modules[name] = fakeModule

for v in Enumerators.ScriptCode.__values__:
    try:
        createModule('encodings.mac_' + str(v).lower()[2:], TECManager.getTextEncoding(script=int(v)))
    except MacOS.Error:
        # kTextUnsupportedEncodingError
        pass
