import distutils.sysconfig
from distutils.core import setup
from distutils.extension import Extension
from Pyrex.Distutils import build_ext

setup(
    name        = 'TECManager',
    version     = '0.2',
    description = "Pythonic wrapper for the Text->Unicode functionality of Text Encoding Conversion Manager",
    long_description = 'Pythonic wrapper for TECManager, replaces built-in mac_encodings with TECM versions',
    url         = 'http://undefined.org/python/',
    maintainer  = 'Bob Ippolito',
    maintainer_email = 'bob@redivi.com',
    license     = 'Python',
    platforms   = ['Mac OSX'],
    keywords    = ['TECManager', 'Unicode', 'Text Encoding'],

    ext_modules=[
        Extension('TECManager._TECManager', ['src/_TECManager.pyx'], extra_link_args=['-framework', 'CoreServices']),
    ],

    packages = ['TECManager'],
    package_dir = {'TECManager':'lib'},
    cmdclass = {'build_ext': build_ext}
)
