import unittest
import os
import MacOS
from TECManager import *

class TECManagerTestCase(unittest.TestCase):
    def testHebrewMultichar(self):
        self.assertEquals(u'\u05b8\uf87f', ConvertToUnicode('\xde', script=smHebrew))
    def testMacRoman(self):
        self.assertEquals(u'\u2022\u2022', ConvertToUnicode('\xa5\xa5', script=smRoman))
    def testBadInput(self):
        try:
            ConvertToUnicode('hi\xFF\xef', script=smJapanese, mask=0)
        except MacOS.Error:
            pass
        else:
            raise ValueError
if __name__ == '__main__':
    unittest.main()
